import os
import yaml
import json
from pymatgen.core.composition import Composition
from pymatgen.core.structure import Structure, Molecule
from pyxtal import pyxtal
from config import *
from structure.core import min_distance

def generate_random_structure(comps, dim):
    random_structures = []
    elements = []
    n_elmnt = []
    if dim == 3:
        with open(os.path.join(bulk_structure_optimization_dir,'bulk_structure.dat'), 'a') as f:
            f.write('Random bulk structures generattion for {}'.format(comps)+'\n')
        for a_comp in comps:
            with open(os.path.join(bulk_structure_optimization_dir,'bulk_structure.dat'), 'a') as f:
                f.write('Composition: {}'.format(a_comp)+'\n')
            for e, n in Composition(a_comp).items():
                elements.append(str(e))
                n_elmnt.append(int(n))
# 3D perioduc bulk
            for sg in range(1,231):
                r_b = generate_random_bulk_space_group(sg, elements, n_elmnt, 1.1, min_n_atom = input_list['min_atom_bulk'], max_n_atom = input_list['max_atom_bulk'], exclude_list = input_list['exc_atom_bulk'])
                random_structures.extend(r_b) 

                with open(os.path.join(bulk_structure_optimization_dir,'bulk_structure.dat'), 'a') as f:
                    f.write('Number of random structures generated by PyXtal with space group {}: {}'.format(int(sg), len(r_b))+'\n')
# store structures
        if len(random_structures) == 0:
            with open(log_file, 'a') as f:
                f.write('Warning. No random bulk structure is generated.'+'\n')
        else:
            random_structures_dict = []
            for i in range(len(random_structures)):
                random_structures_dict.append(random_structures[i].as_dict())
            with open(os.path.join(bulk_structure_optimization_dir,'random_structures.json'),'w') as f:
                json.dump(random_structures_dict, f)
            with open(log_file, 'a') as f:
                f.write('Number of random bulk structures: {}'.format(len(random_structures))+'\n')
# cluster 
    if dim == 0:
        with open(os.path.join(bulk_structure_optimization_dir,'bulk_structure.dat'), 'a') as f:
            f.write('Random cluster structures generattion for {}'.format(comps)+'\n')
        for a_comp in comps:
            with open(os.path.join(bulk_structure_optimization_dir,'bulk_structure.dat'), 'a') as f:
                f.write('Composition: {}'.format(a_comp)+'\n')
            for e, n in Composition(a_comp).items():
                elements.append(str(e))
                n_elmnt.append(int(n))
            for sg in range(1,33):
                r_c = generate_random_cluster_space_group(sg, elements, n_elmnt, min_n_atom = input_list['min_atom_cluster'] , max_n_atom = input_list['max_atom_cluster'], exclude_list = input_list['exc_atom_cluster'])
                random_structures.extend(r_c)

                with open(os.path.join(bulk_structure_optimization_dir,'bulk_structure.dat'), 'a') as f:
                    f.write('Number of random cluster structures generated by PyXtal with space group {}: {}'.format(int(sg), len(r_c))+'\n')

# store structures
        if len(random_structures) == 0:
            with open(log_file, 'a') as f:
                f.write('Warning: no cluster structure is generated.'+'\n')
        else: 
            random_structures_dict = []
            for i in range(len(random_structures)):
                random_structures_dict.append(random_structures[i].as_dict())
            
            with open(os.path.join(bulk_structure_optimization_dir,'cluster_structures.json'),'w') as f:
                json.dump(random_structures_dict, f)
            with open(log_file, 'a') as f:
                f.write('Number of random cluster structures: {}'.format(len(random_structures))+'\n')

def generate_random_bulk_space_group(space_group, elements, n_elmnt, vf, min_n_atom, max_n_atom, exclude_list):
    min_d = min_distance() 
    r_bulk_structures = []
    nmax = 1
    n_element = [int(n_el) * nmax for n_el in n_elmnt]
    while sum(n_element) <= max_n_atom: 
        if sum(n_element) >= min_n_atom and sum(n_element) not in exclude_list:
            r_bulk = pyxtal()
            for attempt in range(20):
                try:
                    r_bulk.from_random(3, space_group, elements, n_element, vf)
                except:
                    r_bulk = False
                    continue
                if r_bulk:
                    if r_bulk.to_pymatgen().is_valid(min_d):
                        r_bulk_structures.append(r_bulk.to_pymatgen())
                        break
        nmax = nmax + 1
        n_element = [int(n_el) * nmax for n_el in n_elmnt]                 
    return r_bulk_structures

def generate_random_cluster_space_group(space_group, elements, n_elmnt, min_n_atom, max_n_atom, exclude_list):
    min_d = min_distance()
    r_cluster_structures = []
    nmax = 1
    n_element = [int(n_el) * nmax for n_el in n_elmnt]
    while sum(n_element) <= max_n_atom:
        if sum(n_element) >= min_n_atom and sum(n_element) not in exclude_list:
            r_cluster = pyxtal()
            for attempt in range(10):
                try:
                    r_cluster.from_random(0, space_group, elements, n_element, 1.2)
                except:
                    r_cluster = False
                    continue
                if r_cluster:
                    if r_cluster.to_pymatgen().is_valid(min_d):
                        try:
                            cluster = r_cluster.to_pymatgen().get_boxed_structure(20,20,20) 
                            r_cluster_structures.append(cluster)
                        except:
                            pass
        nmax = nmax + 1
        n_element = [int(n_el) * nmax for n_el in n_elmnt]
    return r_cluster_structures
